<?php

namespace Drupal\course_book\Plugin\course\CourseObject;

use Drupal\course\Entity\CourseObjectFulfillment;

/**
 * Course fulfillment class for books.
 */
class CourseObjectBookFulfillment extends CourseObjectFulfillment {

  /**
   * Define storage for book page views.
   */
  function optionsDefinition() {
    return array('book_fulfillment' => array());
  }

  /**
   * Grade (track) the book based on the fulfillment data.
   */
  function grade() {
    $user = $this->getUser();

    /* @var $book_manager Drupal\book\BookManager */
    $book_manager = \Drupal::service('book.manager');
    $toc = $book_manager->getTableOfContents($this->getCourseObject()->getInstanceId(), \Drupal::config('course_book.settings')->get('depth', 100));

    if (course_book_count($this->getCourseObject()->getInstanceId()) == 0) {
      // Book has no pages. Complete object.
      $this->setComplete(1)->save();
      return;
    }

    if ($this->getCourseObject()->getOption('book_tracking') == 'all') {
      $nids = array_keys($toc);
      $fulfillment = $this->getOption('book_fulfillment');
      $viewed = $fulfillment ? array_keys(array_filter($fulfillment)) : array();
      if (!array_diff($nids, $viewed)) {
        $this->setComplete(1)->save();
      }
    }
    elseif ($this->getOption('book_tracking') == 'one') {
      $this->setComplete(1)->save();
    }
  }

}
