<?php

namespace Drupal\course_content\Plugin\course\CourseObject;

use Drupal\course_content\Course\Object\CourseObjectNode;
use Drupal\node\Entity\NodeType;

/**
 * @CourseObject(
 *   id = "content",
 *   label = "Course content",
 *   handlers = {
 *     "fulfillment" = "\Drupal\course_content\Course\Object\CourseObjectNodeFulfillment"
 *   }
 * )
 */
class CourseObjectContent extends CourseObjectNode {

  /**
   * If course object is saved without configuration, make sure we have a
   * default node type.
   */
  function optionsDefinition() {
    $options = parent::optionsDefinition();
    if ($this->getNodeTypes()) {
      $options['node_type'] = $this->getNodeTypes()[0];
    }
    return $options;
  }

}
