<?php

namespace Drupal\course\EventSubscriber;

use Drupal;
use Drupal\node\Entity\NodeType;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use function course_get_course_object;

class CourseEventSubscriber implements EventSubscriberInterface {

  public static function getSubscribedEvents() {
    return [
      // Set priority to 28 so we can get around the page cache.
      KernelEvents::REQUEST => ['onRequest', 28],
    ];
  }

  /**
   * Check if the current node will fulfill an object.
   *
   * @param GetResponseEvent $event
   */
  public function onRequest(GetResponseEvent $event) {
    course_context();
  }

}
