<?php

namespace Drupal\course\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class CourseRouteSubscriber extends RouteSubscriberBase {

  /**
   * Mark some views-provided routes as admin routes.
   *
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($route = $collection->get('view.course_enrollments.course')) {
      $route->setOption('_admin_route', 'TRUE');
    }

    if ($route = $collection->get('view.course_enroll.course')) {
      $route->setOption('_admin_route', 'TRUE');
    }
  }

}
