<?php

namespace Drupal\course\Schema;

use Drupal\Core\Entity\Sql\SqlContentEntityStorageSchema;
use Drupal\Core\Field\FieldStorageDefinitionInterface;

/**
 * Defines the course enrollment schema handler. Ensure that a user can only
 * have one enrollment per course.
 */
class CourseEnrollmentStorageSchema extends SqlContentEntityStorageSchema {

  /**
   * {@inheritdoc}
   */
  protected function getSharedTableFieldSchema(FieldStorageDefinitionInterface $storage_definition, $table_name, array $column_mapping) {
    $schema = parent::getSharedTableFieldSchema($storage_definition, $table_name, $column_mapping);
    if ($table_name === 'course_enrollment' && $storage_definition->getName() == 'eid') {
      $schema['unique keys']['cid_uid'] = [
        'cid',
        'uid',
      ];
    }
    return $schema;
  }

}
